% load in the chains you want to see:
load 'chainz_smm'

% dimensions of the chain
[a, b, c] = size(chains)

% burnin: how much you want to discard from the rows of the chain 
burnin = 1; % not needed

chain = permute(chains,[1 3 2]);
chain =  reshape(chain,[],size(chains,2),1);
%%
%chain=cat(1,c1,c4);
%chain = reshape(chains, a*c, b);

% now we look for the best estimate: 

min_LL = min(min(chain(:,13)));

% best_est contains the row indices of the best estimators
best_est = find(chain(:,13) == min_LL);
%%
% best_ these contain the parameters and moments correesponding to the best
% estimate:
best_params = chain(best_est(1),1:12);
%%
best_moms = chain(best_est(1),14:26);
%%
lam0= best_params(1)
lam1 = best_params(2)
alph = best_params(3)
up = best_params(4)
down = best_params(5)
by1 = best_params(6)
by2 = best_params(7)
bd1 = best_params(8)
bd2 = best_params(9)
thet = best_params(10)
ymin = best_params(11)
z=best_params(12)
%%
% load 'best_moms'
% 
% if min_L>min_LL
%     display('improvement from to')
%     [min_L min_LL]
%     min_L=min_LL
%     best_moments=best_moms
% save 'best_moms' best_moments min_L

save 'best_params' lam0 lam1 alph up down by1 by2 bd1 bd2 thet ymin
% else
%     display('no improvement, best vs current')
%     [min_L min_LL]
% end
% the targeted moments: 
load mom_targ
% compare the targets and the moments correesponding to the best estimate
'compare the targeted and best moments'
[mom_targ ; best_moms]
