clear%%%% This file executes the estimation in parallel on multiple nodes (each running multiple cores). 
clear all
close all
clc

rng('shuffle')
%Parameters
% load numerical_params
% load 'best_param522_3' lam0 lam1 alph up down by1 by2 bd1 bd2 thet ymin z% start out from best value of global grid search
% load omega
% load mom_targ
% 
% ny=groups;
% nd=groups;
% nf=ny*nd;
% 
% x=linspace(xmin,xmax,nx);
% tend=tstart+samplerep;
% 
% [dn,ytil]=copula_new(by1,by2,bd1,bd2,thet,groups);
% yn=ymin+ytil;
% 
% [Sxv2,w,WU,rs]= values_full_with_u(dn,yn,bet,lam0,lam1,alph,nx,nf,x,up,down,z,by1,by2,bd1,bd2,thet,ymin);
% [stat, firm, hc, wage, firmp, workerp, espell, jspell, uspell, bench, hcneg]=dataset_only_extended(Sxv2,w,WU,dn,yn,bet,lam0,lam1,alph,ny,nx,nd,nf,x,up,down,z,T,N,rs);
% [mom_est] =moments(stat, firm, hc, wage, espell, jspell, uspell,N,T,lam1, z, yn, x);
% 
% [mom_targ; mom_est ] 
% LL = sum((log(mom_targ./mom_est)).^2./omega,2)

%% Parallel estimation on multiple cores
Nit = 400;
nwork=20  %12 for the cluster

load numerical_params_smm
load 'best_param522_4' lam0 lam1 alph up down by1 by2 bd1 bd2 thet ymin z
load omega
load mom_targ

parfor Nchain=1:nwork
chains(:,:,Nchain)=smm(mom_targ, omega, Nit,lam0, lam1, alph, up, down, by1, by2, bd1, bd2, thet, ymin, z, xmin, xmax, T, nx, N, bet, groups)
end

chains1=chains;
load chainz_smm
chains=cat(3,chains,chains1);
save chainz_smm chains
