function [stat, firm, hc, wage, firmp, workerp, espell, jspell, uspell, bench, hcneg]= dataset_only_extended(Sxv2,w,WU,dn,yn,bet,lam0,lam1,alph,ny,nx,nd,nf,x,up,down,z,T,N,rs)

wst=w(:);
Sst=Sxv2(:);
%WUst=WU(:);
T2=T*10;
N2=N;

% start
stat = zeros(1,N2);
firm = ones(1,N2);
bench = ones(1,N2);
hcneg = ones(1,N2);
hc = ones(1,N2);

espell=zeros(1,N2);
jspell=zeros(1,N2);
uspell=zeros(1,N2);


%% Simulate Worker histories

% Compute employment status, firm number (by surplus), HC, and Benchmarks
% (HC and firm number)

t=2;
conv=1;
while conv>.0005
    %shocks
    fu=(rand(1,N2)<lam0);
    fj=(rand(1,N2)<lam1);
    up_s=(rand(1,N2)<up);
    down_s=(rand(1,N2)<down);
    s=rand(1,N2);
    draw=ceil(rand(1,N2)*nf);

    stat1=stat.*(1-(s<dn(firm)'))+(1-stat).*fu.*[Sst((hc-1)*nf+draw)>0]';
    
    hc1=stat1.*(up_s.*min(hc+1,nx)+(1-up_s).*hc)+(1-stat1).*(down_s.*max(hc-1,1)+(1-down_s).*hc);
    
    firm1=(stat1-stat==1).*draw+...
         (stat1==1).*(stat==1).*(fj.*(Sxv2(draw+(hc1-1)*nf)>Sxv2(firm+(hc1-1)*nf)).*draw+(1-fj.*(Sxv2(draw+(hc1-1)*nf)>Sxv2(firm+(hc1-1)*nf))).*firm)...
        +(1-stat1).*firm;
    
    reneg=rs((draw-1)*nx*nx*nf*(nf+1)+(hc1-1)*nx*nf*(nf+1)+(hcneg-1)*nf*(nf+1)+(bench)*nf+(firm))';
    
    bench1=(stat1-stat==1).*zeros(1,N2)+(1-(stat1==1)).*zeros(1,N2)+...
        (stat1==1).*(stat==1).*...
        (fj.*(Sxv2(draw+(hc1-1)*nf)>Sxv2(firm+(hc1-1)*nf)).*firm+...
        fj.*(reneg).*draw+...
        ((1-fj)+fj.*(1-(Sxv2(draw+(hc1-1)*nf)>Sxv2(firm+(hc1-1)*nf))-(reneg))).*bench);    
        %fj.*((Sxv2(draw+(hc1-1)*nf)<=Sxv2(firm+(hc1-1)*nf))&((Sxv2(draw+(hc1-1)*nf)>Sxv2(max(bench+(hcneg-1)*nf,1)))|(bench==0))).*draw+...
        %(1-(fj.*(Sxv2(draw+(hc1-1)*nf)>Sxv2(max(bench+(hcneg-1)*nf,1))| (Sxv2(draw+(hc1-1)*nf)>Sxv2(firm+(hc1-1)*nf))|(bench==0)))).*bench);
        
    hcneg1=stat1.*(((bench1~=bench) | firm1~=firm ).*hc1+(1-(bench1~=bench | firm1~=firm )).*hcneg)+(1-stat1).*hc1;
     
    espell1=stat.*stat1.*(espell+1)+(1-stat).*stat1.*1;
    jspell1=stat.*stat1.*(firm1==firm).*(jspell+1)+(1-stat).*stat1.*(firm1==firm).*1;
    uspell1=[stat1==0].*(uspell+ones(1,N2));
    
    if t>1500
    conv=abs(mean(hc1)/mean(hc)-1)+abs(mean(hcneg1)/mean(hcneg)-1)+abs(mean(stat1)/mean(stat)-1)+abs(mean(bench1)/mean(bench)-1)+abs(mean(firm1)/mean(firm)-1)+abs(mean(espell1)/mean(espell)-1) ;  
    end
    
    espell=espell1;
    jspell=jspell1;
    uspell=uspell1;
    firm=firm1;
    stat=stat1;
    hcneg=hcneg1;
    bench=bench1;
    hc=hc1;
   
    conv;
    
    if t>T2
        conv=0;        
        display 'no convergence, increase T2'
    end
    t=t+1;
end

fu=(rand(T,N)<lam0);
fj=(rand(T,N)<lam1);
up_s=(rand(T,N)<up);
down_s=(rand(T,N)<down);
s=rand(T,N);
draw=ceil(rand(T,N)*nf);
stat=[stat; zeros(T-1,N)];
firm=[firm; ones(T-1,N)];
bench=[bench;ones(T-1,N)];
hcneg=[hcneg; ones(T-1,N)];
hc=[hc; ones(T-1,N)];
espell=[espell;ones(T-1,N)];
jspell=[jspell; ones(T-1,N)];
uspell=[uspell; ones(T-1,N)];

for t=2:T
    stat(t,:)=stat(t-1,:).*(1-(s(t,:)<dn(firm(t-1,:))'))+(1-stat(t-1,:)).*fu(t,:).*[Sst((hc(t-1,:)-1)*nf+draw(t-1,:))>0]';
    hc(t,:)=stat(t,:).*(up_s(t,:).*min(hc(t-1,:)+1,nx)+(1-up_s(t,:)).*hc(t-1,:))+...
        (1-stat(t,:)).*(down_s(t,:).*max(hc(t-1,:)-1,1)+(1-down_s(t,:)).*hc(t-1,:));
    firm(t,:)=(stat(t,:)-stat(t-1,:)==1).*draw(t,:)+(stat(t,:)==1).*((stat(t-1,:)==1)).*...
        (fj(t,:).*(Sxv2(draw(t,:)+(hc(t,:)-1)*nf)>Sxv2(firm(t-1,:)+(hc(t,:)-1)*nf)).*draw(t,:)+...
        (1-fj(t,:).*(Sxv2(draw(t,:)+(hc(t,:)-1)*nf)>Sxv2(firm(t-1,:)+(hc(t,:)-1)*nf))).*firm(t-1,:))...
        +(1-stat(t,:)).*firm(t-1,:);
    
    reneg=rs((draw(t,:)-1)*nx*nx*nf*(nf+1)+(hc(t,:)-1)*nx*nf*(nf+1)+(hcneg(t-1,:)-1)*nf*(nf+1)+(bench(t-1,:))*nf+(firm(t-1,:)))';
    
    bench(t,:)=(stat(t,:)-stat(t-1,:)==1).*zeros(1,N)+(1-(stat(t,:)==1)).*zeros(1,N)+...
        (stat(t,:)==1).*(stat(t-1,:)==1).*...
        (fj(t,:).*(Sxv2(draw(t,:)+(hc(t,:)-1)*nf)>Sxv2(firm(t-1,:)+(hc(t,:)-1)*nf)).*firm(t-1,:)+...
        fj(t,:).*(reneg).*draw(t,:)+...
        ((1-fj(t,:))+fj(t,:).*(1-(Sxv2(draw(t,:)+(hc(t,:)-1)*nf)>Sxv2(firm(t-1,:)+(hc(t,:)-1)*nf))-(reneg))).*bench(t-1,:));    
   
     hcneg(t,:)=stat(t,:).*(((bench(t,:)~=bench(t-1,:)) | ((firm(t,:)~=firm(t-1,:)))).*hc(t,:)+...
        +(1-((bench(t,:)~=bench(t-1,:)) | (firm(t,:)~=firm(t-1,:)))).*hcneg(t-1,:))+...
        (1-stat(t,:)).*hc(t,:);
    espell(t,:)=stat(t-1,:).*stat(t,:).*(espell(t-1,:)+1)+(1-stat(t-1,:)).*stat(t,:).*1;
    jspell(t,:)=stat(t-1,:).*stat(t,:).*(firm(t-1,:)==firm(t,:)).*(jspell(t-1,:)+1)+...
        (1-stat(t-1,:)).*stat(t,:).*(firm(t-1,:)==firm(t,:)).*1;
    uspell(t,:)=[stat(t,:)==0].*(uspell(t-1,:)+ones(1,N));
end


%% Back out Wages
wind=(hcneg-1)*nf*(nf+1)+(bench)*nf+firm;
wage=wst(wind).*stat;

firmp=stat.*yn(firm);
workerp=x(hc);
%output=stat.*(firmp+workerp);
%sep=dn(firm);
    