function chain = smm(mom_targ, omega, Nit,lam0, lam1, alph, up, down, by1, by2, bd1, bd2, thet, ymin, z, xmin, xmax, T, nx, N, bet, groups)

ny=groups;
nd=groups;
nf=ny*nd;
x=linspace(xmin,xmax,nx);

mom=mom_targ;
parold=[lam0 lam1 alph up down by1 by2 bd1 bd2 thet ymin z];
[dn,ytil]=copula_new(by1,by2,bd1,bd2,thet,groups);
yn=ymin+ytil;

rng('shuffle');

[Sxv2,w,WU,rs]= values_full_with_u(dn,yn,bet,lam0,lam1,alph,nx,nf,x,up,down,z,by1,by2,bd1,bd2,thet,ymin);
[stat, firm, hc, wage, espell, jspell, uspell]=dataset_only(Sxv2,w,WU,dn,yn,bet,lam0,lam1,alph,ny,nx,nd,nf,x,up,down,z,T,N,rs);
simmom_old = moments(stat, firm, hc, wage, espell, jspell, uspell, N,T,lam1,z, yn,x);

clear stat firm wage firmp workerp espell jspell uspell rs Sxv2 WU w
simmom(1,:) = simmom_old;
noise=1/50*abs(parold+[0 0 0 0 0 0 0 0 0 0 0 0]);

% now we iterate 
chain=zeros(Nit,27);
for it=1:Nit
        rng('shuffle')
        %par=par+(pair-1)*normrnd(0,.05,1,1)
        %heat=1/3;
        lam0_t=lam0;%+normrnd(0,noise(1),1,1) fixing lam_0 at target
        lam0=(lam0_t>.01)*lam0_t+(1-(lam0_t>.01))*lam0;
        
        % new parameters
        lam1_t=lam1+normrnd(0,noise(2),1,1);
        %lam1=(lam1_t>.01 & lam1_t<lam0)*lam1_t+(1-(lam1_t>.01 & lam1_t<lam0))*lam1;
        lam1=(lam1_t>.01)*lam1_t+(1-(lam1_t>.01))*lam1;
        alph_t=alph+normrnd(0,noise(3),1,1);
        alph=alph_t*(alph_t<1)*(alph_t>0)+alph*(1-(alph_t<1)*(alph_t>0));
        down_t=down+normrnd(0,noise(5),1,1);
        down=down_t*(down_t>1e-3 & down_t<1)+(1-(down_t>1e-3 & down_t<1))*down;
         up_t=up + normrnd(0,noise(4),1,1);
         up = up_t*(up_t>1e-3 & up_t<1)+(1-(up_t>1e-3 & up_t<1))*up;
         by1_t=by1+normrnd(0,noise(6),1,1);
         by2_t=by2+normrnd(0,noise(7),1,1);
         by1=by1_t*(by1_t>0)+by1*(1-(by1_t>0));
         by2=by2_t*(by2_t>0)+by2*(1-(by2_t>0));
         bd1=bd1+normrnd(0,noise(8),1,1);
         bd2=bd2+normrnd(0,noise(9),1,1);
%         bd1=bd1_t*(bd1_t>0 & 10*bd1_t<bd2_t)+bd1*(1-(bd1_t>0 & 10*bd1_t<bd2_t)); % parameter restriction (mean d cannot be too high)
 %        bd2=bd2_t*(bd2_t>0 & 10*bd1_t<bd2_t)+bd2*(1-(bd2_t>0 & 10*bd1_t<bd2_t));
         thet=thet+normrnd(0,noise(10),1,1);
         ymin=ymin+normrnd(0,noise(11),1,1);
         z=z+normrnd(0,noise(12),1,1);
          [dtil,ytil]=copula_new(by1,by2,bd1,bd2,thet,groups);
             yn=ymin+ytil;
              dn=dtil;
              
           [Sxv2,w,WU,rs]= values_full_with_u(dn,yn,bet,lam0,lam1,alph,nx,nf,x,up,down,z,by1,by2,bd1,bd2,thet,ymin);   
           [stat, firm, hc, wage, espell, jspell, uspell]=dataset_only(Sxv2,w,WU,dn,yn,bet,lam0,lam1,alph,ny,nx,nd,nf,x,up,down,z,T,N,rs);
           clear hcneg bench firmp workerp rs Sxv2 WU w
            simmom(2,:) = moments(stat, firm, hc, wage, espell, jspell, uspell, N,T,lam1,z, yn, x);
            clear stat firm hc wage espell jspell uspell 

           Lmult = 150;
            L=Lmult*sum((log(repmat(mom,2,1)./simmom)).^2./repmat(omega,2,1),2);

            switchprob=min(exp(-L(2)+L(1)),1);
          
        dec=rand(1,1);
        swit=dec<switchprob;
        lam0=lam0*swit+parold(1)*(1-swit);
        lam1=lam1*swit+parold(2)*(1-swit);
        alph=alph*swit+parold(3)*(1-swit);
        up=up*swit+parold(4)*(1-swit);
        down=down*swit+parold(5)*(1-swit);
        by1=by1*swit+parold(6)*(1-swit);
        by2=by2*swit+parold(7)*(1-swit);
        bd1=bd1*swit+parold(8)*(1-swit);
        bd2=bd2*swit+parold(9)*(1-swit);
        thet=thet*swit+parold(10)*(1-swit);
        ymin=ymin*swit+parold(11)*(1-swit);
        z=z*swit+parold(12)*(1-swit);
     
        % now we have to update the 'old' parameters and moments 
             if swit ==1 
                simmom(1,:) = simmom(2,:) ;
                parold = [lam0 lam1 alph up down by1 by2 bd1 bd2 thet ymin z];

             end 
             chain(it,:)=[lam0 lam1 alph up down by1 by2 bd1 bd2 thet ymin z sum((log(mom./simmom(swit+1,:)).^2)./omega) simmom(swit+1,:) ];

             if floor(it/25)-it/25==0
             it
             end
end
% 
% % 
% lam0=param(1)
% lam1=param(2) 
% alph =param(3)
% up =param(4)
% down= param(5)
% by1 =param(6)
% by2 =param(7)
% bd1 =param(8)
% bd2 =param(9)
% thet =param(10)
% ymin =param(11)
% z=param(12)
% 
% om
% 
% 
% 
