* File of the Project "670" - 3_mass_layoff_and_macroind.do
* Content: Create indicator for masslayoff 

clear
*set max_memory 20g
cap log close

log using "$log/3_mass_layoff_and_macroind.log", replace

use "$orig/siab_7510_v1_bhp_basis_v1", clear

* a masslayoff happened if 1) employment reduction by >30%, 2) but no firm death, 3)at firms with more than 50 employees. the rest is additional robustness criteria 
bys betnr: gen masslo=(az_ges_vz[_n]/az_ges_vz[_n-2]<.7 & az_ges_vz[_n]/az_ges_vz[_n-2]>.01 &az_ges_vz[_n-2]>50 &az_ges_vz[_n-2]/az_ges_vz[_n-3]<1.3 &az_ges_vz[_n+1]/az_ges_vz[_n-2]<.9 &jahr[_n+1]-jahr[_n-3]==4)
* 20 instead of 30 percent
bys betnr: gen masslo2=(az_ges_vz[_n]/az_ges_vz[_n-2]<.8 & az_ges_vz[_n]/az_ges_vz[_n-2]>.01 &az_ges_vz[_n-2]>50 &az_ges_vz[_n-2]/az_ges_vz[_n-3]<1.3 &az_ges_vz[_n+1]/az_ges_vz[_n-2]<.9 &jahr[_n+1]-jahr[_n-3]==4)
rename jahr calyr
keep betnr masslo masslo2 calyr az_ges_vz w93_3_gen te_med lzt* grd*

save "$data/masslayoff.dta", replace
